
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../../gsmcomon.h"
#include "../../device/gsmdev.h"
#include "phonet.h"

GSM_Error GSM_Protocol_PHONET::Open(char *Prot)
{
        (*Debug)->Deb("[STATE     : opening protocol]\n");

        if (!strcmp(Prot,"phonetirda")) return GSM_ERR_NONE;
        return GSM_ERR_UNKNOWN;
}

GSM_Error GSM_Protocol_PHONET::Close()
{
        return GSM_ERR_NONE;
}

GSM_Error GSM_Protocol_PHONET::Write(unsigned char *buffer, int length, unsigned char type)
{
	unsignedstring Buffer;

	Buffer.push_back(PHONET_FRAME_ID);
	Buffer.push_back(PHONET_DEVICE_PHONE);
	Buffer.push_back(PHONET_DEVICE_PC);
	Buffer.push_back(type);
	Buffer.push_back(length/256);
	Buffer.push_back(length%256);
	Buffer.append((const unsigned char *)buffer,length);

	GSM_Protocol::Write(buffer,length,type);
	return (*Device)->Write(Buffer.data(),Buffer.size());
}

GSM_Error GSM_Protocol_PHONET::Dispatch(unsigned char *buffer, int length, int *position)
{
	int len, i = (*position);

	while (i < length) {
		if (State == MSG_Sync) {
			CheckReadByte(buffer[i], PHONET_FRAME_ID, MSG_Destination);
		} else if (State == MSG_Destination) {
			CheckReadByte(buffer[i], PHONET_DEVICE_PC, MSG_Source);
		} else if (State == MSG_Source) {
			CheckReadByte(buffer[i], PHONET_DEVICE_PHONE, MSG_Type);
		} else if (State == MSG_Type) {
			MsgReceived.Type 	= buffer[i];	
			State 			= MSG_Length1;
		} else if (State == MSG_Length1) {
			MsgReceived.Length 	= buffer[i]*256;
			State 			= MSG_Length2;
		} else if (State == MSG_Length2) {
			MsgReceived.Buffer.clear();
			MsgReceived.Length 	= MsgReceived.Length + buffer[i];
			State 			= MSG_Message;
		} else if (State == MSG_Message) {
			len = length - i;
			if (len > MsgReceived.Length) len = MsgReceived.Length;

			MsgReceived.Buffer.append((const unsigned char *)buffer+i,len);
			i+=len;

			if (MsgReceived.Buffer.size() != MsgReceived.Length) continue;

			(*position)		= i;
			State 			= MSG_Sync;
			return GSM_ERR_NEWMESSAGE;
		}
		i++;
	}
	(*position) = i;
	return GSM_ERR_NONE;
}
